#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <baeume.h>
//#include "newick.h"



// Die folgende Funktion erzeugt fuer die Endknoten zwei Zeiger die auf NULL gesetzt werden
int create_null_childs(struct node * nodeptr){

  if(nodeptr->edges != NULL){
    create_null_childs(nodeptr -> edges[0]);

  }else{
    nodeptr -> edges = (node **) malloc(2 * sizeof(struct node *));
    nodeptr -> edges[0] = NULL;
    nodeptr -> edges[1] = NULL;
    return 1;
  }
  if(nodeptr->edges != NULL){
    create_null_childs(nodeptr -> edges[1]);
  }else{
    nodeptr -> edges = (node **) malloc(2 * sizeof(struct node *));
    nodeptr -> edges[0] = NULL;
    nodeptr -> edges[1] = NULL;
    return 1;
  }
}
// Diese Funktion bekommt einen Zeiger auf einen Knoten in einem Baum
// und traegt in die Kantenlaenge jedes Knotens dieses Unterbaumes
// die Gesamtkantenlange, gemessen vonm uebergebenen Knoten ein.
int rewrite_edgelength2age(struct node *nodeptr){
  if(nodeptr->edges[0] != NULL){

    nodeptr->edges[0]->edgelength = nodeptr->edges[0]->edgelength + nodeptr->edgelength;
    
    rewrite_edgelength2age(nodeptr->edges[0]);
  
  }else
    return 1;
  
  if(nodeptr->edges[0] != NULL){
  
    nodeptr->edges[1]->edgelength = nodeptr->edges[1]->edgelength + nodeptr->edgelength;
    
    rewrite_edgelength2age(nodeptr->edges[1]);
  
  }else
    return 1;
}
// Die folgende Funktion geht rekursiv durch einen Baum
// und schreibt Labels an jeden Knoten, die sich aus den beiden darunterliegenden Labels ergeben.
//fuer baeume in char notation abcd ab cd a b c d
int write_labels_in_tree(nodeptr nodeptr){
 char * twostrings[2];
  int stringlaenge;
 if(nodeptr->edges[0] != NULL){
   write_labels_in_tree(nodeptr -> edges[0]);
 }else{
   return 1;
 }
  if(nodeptr -> edges[1] != NULL){
    write_labels_in_tree(nodeptr -> edges[1]);
  }else{
    return 1;
  }
  free(nodeptr -> label);
  stringlaenge = strlen(nodeptr -> edges[0] -> label) + strlen(nodeptr -> edges[1] -> label);
  nodeptr -> label = (char *) malloc ( (stringlaenge  + 1) * sizeof(char));

  if(strcmp(nodeptr -> edges[0] -> label, nodeptr -> edges[1] -> label) < 0){
    sprintf(nodeptr -> label, "%s%s", nodeptr -> edges[0] -> label, nodeptr -> edges[1] -> label);
  }else{
    sprintf(nodeptr -> label, "%s%s", nodeptr -> edges[1] -> label, nodeptr -> edges[0] -> label);
  }
  qsort(nodeptr -> label, stringlaenge, sizeof(char), comp_asci);



  return 1;


}


// Die folgende Funktion geht rekursiv durch einen Baum
// und schreibt Labels an jeden Knoten, die sich aus den beiden darunterliegenden Labels ergeben.
//fuer baeume in int notation 1,2,3,4 1,2 3,4 1 2 3 4
int write_labels_in_tree_extended(nodeptr nodeptr){
 char * twostrings[2];
  int stringlaenge;
 if(nodeptr->edges[0] != NULL){
   write_labels_in_tree(nodeptr -> edges[0]);
 }else{
   return 1;
 }
  if(nodeptr -> edges[1] != NULL){
    write_labels_in_tree(nodeptr -> edges[1]);
  }else{
    return 1;
  }
  free(nodeptr -> label);
  stringlaenge = strlen(nodeptr -> edges[0] -> label) + strlen(nodeptr -> edges[1] -> label);
  nodeptr -> label = (char *) malloc ( (stringlaenge  + 2) * sizeof(char));

  if(strcmp(nodeptr -> edges[0] -> label, nodeptr -> edges[1] -> label) < 0){
    sprintf(nodeptr -> label, "%s,%s", nodeptr -> edges[0] -> label, nodeptr -> edges[1] -> label);
  }else{
    sprintf(nodeptr -> label, "%s,%s", nodeptr -> edges[1] -> label, nodeptr -> edges[0] -> label);
  }
  //qsort(nodeptr -> label, stringlaenge, sizeof(char), comp_asci);



  return 1;


}

/* Diese Funktion zaehlt die Knoten im Baum */
int count_knoten(struct node *nodeptr, int anzahl){
  anzahl++;
  if(nodeptr->edges[0] != NULL){
    
    anzahl = count_knoten(nodeptr->edges[0], anzahl);
  }else{
    return anzahl;
  }
  if(nodeptr->edges[0] != NULL){
    anzahl = count_knoten(nodeptr->edges[1], anzahl);
  }else{
    return anzahl;
  }
}
  
// Die folgende Funktion bekommt einen Zeiger auf die Wurzel eines Baum,s
// eine Knotenliste und die Lange dieser Liste
// Dann wird aus den Knoten der Liste eine Kopie des Baumes erstellt.
// Zurueckgegebn wird ein Zeiger auf den Wurzelnkoten
node * copy_tree(node * knoten, node ** nodelist, int knoten_anzahl){
   static int nr = 0;
   struct node * tmp;
   tmp = nodelist[nr];

   if(knoten -> edges[0] != NULL){

     if(nodelist[nr] -> label != NULL){
        free(nodelist[nr] -> label);
      }

     nodelist[nr] -> label = (char *) malloc ((strlen(knoten -> label) + 1) * sizeof(char));
     strcpy(nodelist[nr] -> label, knoten-> label);

     nodelist[nr] -> edgelength = knoten -> edgelength;
     nodelist[nr] -> edges[0] = nodelist[nr + 1];
     nr++;
     nr = nr % knoten_anzahl;

     copy_tree(knoten -> edges[0], nodelist, knoten_anzahl);
   }else{

     if(nodelist[nr] -> label != NULL){
        free(nodelist[nr] -> label);
      }

     nodelist[nr] -> label = (char *) malloc ((strlen(knoten -> label) + 1) * sizeof(char));
     strcpy(nodelist[nr] -> label, knoten-> label);

     nodelist[nr] -> edgelength = knoten -> edgelength;
     nodelist[nr] -> edges[0] = NULL;
     nodelist[nr] -> edges[1] = NULL;
     nr++;
     nr = nr % knoten_anzahl;
     return nodelist[nr];
   }

   if(knoten -> edges[0] != NULL){
     tmp -> edges[1] = nodelist[nr];
     copy_tree(knoten -> edges[1], nodelist, knoten_anzahl);
   }else{

     if(nodelist[nr] -> label != NULL){
        free(nodelist[nr] -> label);
      }

     nodelist[nr] -> label = (char *) malloc ((strlen(knoten -> label) + 1) * sizeof(char));
     strcpy(nodelist[nr] -> label, knoten-> label);

     nodelist[nr] -> edgelength = knoten -> edgelength;
     nodelist[nr] -> edges[0] = NULL;
     nodelist[nr] -> edges[1] = NULL;
     nr++;
     nr = nr % knoten_anzahl;

     return nodelist[nr];
   }
    return nodelist[nr];

}

//Die folgende Funktion legt eine  Liste der Zeitintervalle und
// der Anzahl der darin liegenden Kanten an
int create_intervall_list(struct intervall_list * int_list, nodeptr * nodelist, int nodelist_length){
   struct intervall_list * list;
   int i,  k;
   list = int_list;

   // Eintrag des ersten Intervalles (Von der Wurzel ausgehend)
   list -> start = 0;
   if(nodelist[0] -> edges[0] -> edgelength < nodelist[0] -> edges[1] -> edgelength){
      list -> stop = nodelist[0] -> edges[0] -> edgelength;
   }else{
     list -> stop = nodelist[0] -> edges[1] -> edgelength;
   }
   list -> anzahl = 2;
   i = 1;
   while(list -> stop < nodelist[nodelist_length - 1] -> edgelength){
     list -> next = (intervall_list *) malloc (sizeof(intervall_list));
     list -> next -> start = list -> stop;
     list -> next -> anzahl = list -> anzahl;
     list = list -> next;
     while(nodelist[i] -> edgelength == list -> start){
       list -> anzahl++;
       i++;
     }
     list -> stop = nodelist[i] -> edgelength;
   }

     return 1;

}


// Diese Funktion bekommt einen Zeiger auf eine Baumwurzel und eine Liste von Namen einiger Endknoten
// Der Baum wird nun so modifiziert, das ein Unterbaum entsteht, der genau die Blaetter der
// Liste enthaelt.
struct node * extract_subtree(struct  node *root_ptr, char **leave_list, int leave_list_length){
  int i;
  // Die Anzahl der zu suchenden Endknoten muss noch eingebaut werden
  struct node *left;
  struct node *right;

  left = NULL;
  right = NULL;

  if(root_ptr -> edges[0] != NULL){

    left = extract_subtree(root_ptr -> edges[0], leave_list, leave_list_length);

  }else{

    i = 0;
    while(i < leave_list_length && strcmp(root_ptr -> label, leave_list[i]) != 0){

      i++;
    }
    if(i < leave_list_length){

      return root_ptr;

    }else{

      free(root_ptr -> label);
      free(root_ptr -> edges);
      free(root_ptr);
      return NULL;
    }
  }
  if(root_ptr -> edges[1] != NULL){
    right = extract_subtree(root_ptr -> edges[1], leave_list, leave_list_length);

  }else{

    i = 0;

    while(i < leave_list_length && strcmp(root_ptr -> label, leave_list[i]) != 0){

      i++;
    }
    if(i < leave_list_length){

      return root_ptr;

    }else{

      free(root_ptr -> label);
      free(root_ptr -> edges);
      free(root_ptr);
      return NULL;
    }
  }

  if(left != NULL && right != NULL){

    root_ptr -> edges[0] = left;
    root_ptr -> edges[1] = right;

    return root_ptr;

  }else if(left == NULL && right == NULL){

    return NULL;
  }else{

    free(root_ptr -> label);
    free(root_ptr -> edges);
    free(root_ptr);

    if(left != NULL){

      return left;
    }else if(right != NULL){

      return right;
    }else{

      printf("Fehler in Funktion \"extract_subtree\"\n");
      exit(1);
    }
  }


}


