#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <topology.h>


//Die folgende Funkion bekommt einen String, der eine Baumtopologie beschreibt und erzeugt eine verkettete
//Liste gemaess dieser Topologie
node * string2tree_mit_zeit(char * string){
  char * pt;
  char ** liste;
  int anzahl;
  int i, l, r;
  struct node ** nodelist;
 
  pt = ergaenze_endknoten(string);
  //printf("String: %s#\n", pt);
  if(pt == NULL){
    printf("Fehler im Topologiestring: %s\n", string);
    return NULL;
  }
  //String hat nun Endknoten
  anzahl = zaehle_zeichen(pt, " ") + 1;
  //printf("Anzahl: %i\n", anzahl);
  liste = (char **) malloc(anzahl * sizeof(char *));
  split_string(pt, liste, anzahl,  " ");
  for(i = 0; i < anzahl; i++){
    qsort(liste[i], strlen(liste[i]), sizeof(char), comp_asci);
    //printf("Sortiert: %i: %s\n", i, liste[i]);
  }
  qsort(liste, anzahl, sizeof(char *), comp_laenge_und_asci);
  //Die Liste zeigt  nun auf die Knotenbezeichner (sortiert)
  nodelist = (node **) malloc(anzahl * (sizeof(node *)));
  for(i = 0 ; i < anzahl; i++){
    nodelist[i] = (node *) malloc(sizeof(node));
    nodelist[i] -> parent = NULL;
    nodelist[i] -> edgelength = -1;
  }
 
  erzeuge_baum_aus_string(liste, anzahl, 0, nodelist);
  return nodelist[0];
  
  
}

//Die folgende Funkion bekommt einen String, der eine Baumtopologie beschreibt und erzeugt eine verkettete
//Liste gemaess dieser Topologie
node * string2tree(char * string){
  char * pt;
  char ** liste;
  int anzahl;
  int i, l, r;
  struct node ** nodelist;
 
  pt = ergaenze_endknoten(string);
  //printf("String: %s#\n", pt);
  if(pt == NULL){
    printf("Fehler im Topologiestring: %s\n", string);
    return NULL;
  }
  //String hat nun Endknoten
  anzahl = zaehle_zeichen(pt, " ") + 1;
  //printf("Anzahl: %i\n", anzahl);
  liste = (char **) malloc(anzahl * sizeof(char *));
  split_string(pt, liste, anzahl,  " ");
  for(i = 0; i < anzahl; i++){
    qsort(liste[i], strlen(liste[i]), sizeof(char), comp_asci);
    //printf("Sortiert: %i: %s\n", i, liste[i]);
  }
  qsort(liste, anzahl, sizeof(char *), comp_laenge_und_asci);
  //Die Liste zeigt  nun auf die Knotenbezeichner (sortiert)
  nodelist = (node **) malloc(anzahl * (sizeof(node *)));
  for(i = 0 ; i < anzahl; i++){
    nodelist[i] = (node *) malloc(sizeof(node));
    nodelist[i] -> parent = NULL;
    nodelist[i] -> edgelength = -1;
  }
 
  erzeuge_baum_aus_string(liste, anzahl, 0, nodelist);
  return nodelist[0];
  
  
}


// Die folgende Funktion bekommt einen Array mit Zeigern auf char,
// einen Zeiger auf die Wurzel eines Baumes und
// die Anzahl der Knoten auf diesen Baum
// Die Zeiger des Arrays werden dann auf die Labels der Baumknoten gesetzt
int write_tree_topology(char ** current_tree_topology, node * root_ptr, int anzahl){
     static int nr = 0;
     if(root_ptr -> edges[0] != NULL){
       current_tree_topology[nr] = root_ptr -> label;
       nr++;
       nr = nr % anzahl;
       write_tree_topology(current_tree_topology, root_ptr -> edges[0], anzahl);
     }else{
       current_tree_topology[nr] = root_ptr -> label;
       nr++;
       nr = nr % anzahl;
       return 1;
     }
      if(root_ptr -> edges[0] != NULL){
        write_tree_topology(current_tree_topology, root_ptr -> edges[1], anzahl);
      }else{
        return 1;
      }
       return 1;
}


// Diese Funktion erzeugt eine Struktur topology_element und gibt einen Zeiger darauf zurueck
struct topology_element * new_topology_element(int anzahl_der_labels){

  struct topology_element *topo;
  topo = (struct topology_element *) malloc(sizeof(struct topology_element));
  topo->anzahl = 0;
  topo->next = NULL;
  topo->label = (char **) malloc(anzahl_der_labels * sizeof(char *));


  return topo;
}
// Diese Funktion bekommt ein Array mit der Topolgie eines Baumes, einen Zeiger auf ein
// Topolgy_elemen sowie die Anzahl der Labels und beschreibt das Topology-element mit dieser
// Topologie
int write_into_topology_element(char ** topology, struct topology_element * t_elem, int anzahl){
   int i;
   for(i = 0; i < anzahl; i++){
      t_elem -> label[i] = (char *) malloc((strlen(topology[i + 1]) + 1) * sizeof(char));
      if(t_elem -> label[i] == NULL){
        printf("Nicht genuegend Speicher in Funktion: write_into_topology_element.\n");
        return 0;
      }

      strcpy(t_elem -> label[i], topology[i + 1]);
    }
     t_elem -> anzahl++;
    return 1;
  }
// Die folgende Funktion bekommt einen Zeiger auf eine Verkettete Liste mit Topologien,
// einen Array mit einer Topologie und die Anahl der Eintrage
// Die Funktion sucht in der liste ob die Topologie (des Arrays) darin vorkommt,
// zurueckgegeben wird ein Zeiger auf das entsprechende Element oder NULL
struct topology_element * suche_topology(struct topology_element * t_elem, char ** t, int anzahl){
   struct topology_element * t_such;
   t_such = t_elem;

    while( t_such != NULL){
       if(vergleiche_topologien(t_such, t, anzahl) == 1){
         return t_such;
       }
      t_such = t_such -> next;
    }
    return t_such;
}
// Die folgende Funktion vergleicht zwei Topologien
// Rueckgabe: 1 falls gleich
//            0 falls ungleich
int vergleiche_topologien(struct topology_element * t1, char ** t2, int anzahl){

   int i = 0;
   while(i < anzahl && (strcmp(t1 -> label[i], t2[i + 1]) == 0)){
     i++;
   }

    if(i < anzahl){
       return 0;
     }else if(i == anzahl){
       return 1;
     }else{
        return -1;
      }
}



//Die folgende Funktion bekommt einen String der eine baumtopologie codiert. 
//Zunaechst wird (rein numerisch) geprueft, ob die Endknoten enthalten sind, falls nicht werden sie
//angefuegt indem das erste Wort ausgelesen wird.
//Zurueckgegeben wird ein Zeiger auf einen String der nun die Endknoten enthaelt.
//Falls der Eingangsstring inkonsistent war wird NULL zurueckgegeben.
char * ergaenze_endknoten(char * baumstring){
  int l; // #  Leerzeichen (Aeste)
  int k; // # Endknoten
  int i;
  char * pt;

  pt = baumstring;

  l = zaehle_zeichen(baumstring, " ");
  k = 0;
  while(*pt != ' '){
    k++;
    pt++;
  }
  //printf("Leerzeichen:(l) %i\nStartlaenge(k): %i\n", l, k);
  if(l == (2 * k) - 2){
    return baumstring;
  }else if(l == k - 2){
    //baumstring = pt;
    pt = (char *) malloc((strlen(baumstring) + 2 * k + 1) * sizeof(char));
    strcpy(pt, baumstring);
    strcat(pt, " ");
    for(i = 0; i < k - 1; i++){
      strncat(pt, baumstring, 1);
      strcat(pt, " ");
      baumstring++;

    }
    strncat(pt, baumstring, 1);
    
   
    return pt;
  }else{
    
    return NULL;
  }
}
  
// Die folgende Funktion bekommt eine sortierte Liste (zunachst nach Stringlaenge, dann alphabetisch,
// wobei die Strings selbst alphabetisch sortiert sind). Ausserdem die Listenlaenge, den aktuellen Knotenindex und
// eine Liste mit Zeiger auf Knoten. Die Liste wir prozessiert und
// die darin kodierte Baumstruktur wird ermittelt, gemaess dieser werden die Knoten der Knotenliste dann verkettet 
// und benannt. 
int erzeuge_baum_aus_string(char ** liste, int anzahl, int knotenindex, node ** knotenliste){ 
  int l, r;
  char stringanfang;
  char * substring;
  l = knotenindex;
  
  if(knotenindex == anzahl){
    return 1;
  }
  
  
  knotenliste[knotenindex] -> label = liste[knotenindex];
  knotenliste[knotenindex] -> edges = (node **) malloc(2 * sizeof(node *));
  if(strlen(liste[knotenindex]) == 1){
    
    knotenliste[knotenindex] -> numofedges = 0;
    knotenliste[knotenindex] -> edges[0] = NULL;
    knotenliste[knotenindex] -> edges[1] = NULL;
    
    return 1;
  }else{
        
    knotenliste[knotenindex] -> numofedges = 2;
    
    stringanfang = *liste[knotenindex];
    l = knotenindex + 1;
    while(*liste[l] != stringanfang){
      l++;
    }
    knotenliste[knotenindex] -> edges[0] = knotenliste[l];
    erzeuge_baum_aus_string(liste, anzahl, l, knotenliste);
  }
  
  substring = substract_strings(liste[knotenindex], liste[l]);
  
  r = knotenindex;
  while(strcmp(substring, liste[r]) != 0){
    r++;
  }
  knotenliste[knotenindex] -> edges[1] = knotenliste[r];
  erzeuge_baum_aus_string(liste, anzahl, r, knotenliste);
  return 1;
}
  
    
     

//Die folgende Funktion bekommt einen Zeiger auf einen String (s),
//eine Liste von Zeiger auf char (liste)
//sowie einen Zeiger auf einen Trennstring
//Jedes Vorkommen des Trennstrings wird zu Begin durch \0 ersetzt
//Die Elemente aus der Liste werden dann auf die Anfaenge der jeweils durch \0 begrenzten
//Substrings gesetzt 
int split_string(char *s, char ** liste, int anzahl, char * trenner){
  
  char * pt;
  int i, j;
  int vorschub;

  
  
  vorschub = strlen(trenner);
  pt = s;
  liste[0] = s; 
  for(i = 1; i < anzahl; i++){
    pt = strstr(pt, trenner);
    *pt = '\0';
    pt += vorschub;
    
    liste[i] = pt;
   
  }
 
  return anzahl;
    
}

  
int zaehle_zeichen(char * s1, char *s2){
  int i = -1;
  char * string;
  string = s1;
  while(string != NULL){
    string = strstr(string, s2);
    if(string){
      string++;
    }
    
    i++;
  }
  return i;
      


}
//Diese Funktion bekommt zwei Zeiger auf Strings
// Dann wird ein String zurueckgegeb, der die Buchstaben des 1. ohne die des 2. enthaelt   
char * substract_strings(char * s1, char * s2){
  char * string;
  int i;
  i = strlen(s1) - strlen(s2);
  if(i < 0){
    return NULL;
  }
  string = (char *) malloc(( i + 1) * sizeof(char));

  while(*s2 != '\0'){
    while(*s1 != *s2){
      strncat(string, s1, 1);
      s1++;
    }
    s1++;
    s2++;
  }
  if(s1 != '\0'){
    strcat(string, s1);
  }  
  
  return string;
}
  
