#programm extrahiert quartette aus allen 780 genbaeumen
use strict;
$| = 1;

open(FH, $ARGV[0]);
my $zeile = <FH>;

#Weiterschieben zu Testzwecken um mit kleinen Baeumen zu arbeiten
#for(my $i = 0; $i < 405; ++$i){
#    $zeile = <FH>;
#}
while($zeile = <FH>){
print "Zeile gelesen\n";
    chomp $zeile;
    (my $nr, my $leafes, my $splitree) = split(/:/, $zeile);
    
print "Zeile zerlegt\n";
    my @QUARTS = extract_quartett_leafes($leafes);
print "Quartette extrahiert\n";    
    foreach my $quart (@QUARTS){
	print extract_splitsubtree($splitree, $quart) . "\n";
    }
}


sub extract_quartett_leafes(){
    my $leaves = $_[0];
    my @LEAVES = split(//, $leaves);
    my @QUARTS = ();
    my $n = @LEAVES - 1; #maximaler Index
    if($n < 3){
	return -1;
    }
    #Initialisiere Zeiger
    my $a = 0; my $b = 1; my $c = 2; my $d = 3;
    while($d != -1){
	@QUARTS = (@QUARTS, $LEAVES[$a] . $LEAVES[$b].  $LEAVES[$c] . $LEAVES[$d]);
	if($d < $n){
	    ++$d;
	}else{
	    if($c < $n - 1){
		++$c;
		$d = $c + 1;
	    }else{
		if($b < $n - 2){
		    ++$b;
		    $c = $b + 1;
		    $d = $c + 1;
		}else{
		    if($a < $n - 3){
			++$a;
			$b = $a + 1;
			$c = $b + 1;
			$d = $c + 1;
		    }else{
			$d = -1;
		    }
		}
	    }
	}
	    
    }
	return @QUARTS;
}







#Die folgende Funktion bekommt einen Splittree und eineBlattbezeicherliste (als String)
# und extrahiert den entsprechenden Unterbaum
sub extract_splitsubtree(){
    my $splittree = $_[0];
    my $leafset = $_[1];

    my @SPLITS = split(" ", $splittree); #Zerlege Splitstring in Komponenten

    my @reduzierte_splits = ();
    foreach my $split (@SPLITS){

        my @zweisplits = split(/\|/, $split);

        $zweisplits[0] = reduziere_substring($zweisplits[0], $leafset);
        $zweisplits[1] = reduziere_substring($zweisplits[1], $leafset);

        @zweisplits = sort {$a cmp $b} @zweisplits;

        if(length($zweisplits[0]) > 1 && length($zweisplits[1]) > 1){
            @reduzierte_splits = ( @reduzierte_splits, $zweisplits[0] . "|" . $zweisplits[1]);
        }


    }
    @reduzierte_splits = sort {$a cmp $b} @reduzierte_splits;
    my $subtree_split = $reduzierte_splits[0];
    for(my $i = 1; $i < @reduzierte_splits; ++$i){
        if($reduzierte_splits[$i] ne $reduzierte_splits[$i - 1]){
            $subtree_split .= " " . $reduzierte_splits[$i];
        }
    }
    #print "@reduzierte_splits \n";
    return$subtree_split;
}

#die folgende Funktion bekommt zwei String und gibt alles aus dem ersten zurueck was auch im zweiten vorhanden ist
sub reduziere_substring(){
    my $string = $_[0];
    my $substring = $_[1];
    my $returnstring = "";
    for(my $i = 0; $i < length($string); ++$i){
        for(my $j = 0; $j < length($substring); ++$j){
            if(substr($string, $i, 1) eq substr($substring, $j, 1)){
                $returnstring = $returnstring . substr($string, $i, 1);
            }
        }
    }

    return $returnstring;
}






