#include <string.h>
#include <stringtree.h>
#include <ranlib.h>
#include <iostream.h>
#include <time.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>


#define frand() ((float) rand() / (RAND_MAX+1.0));
int ZieheGanzeZahl(int limit); //Funktion die eine ganze Zahl von Null bis unter die
                                //eingeg. Grenze angibt.
int comp_number(const void * n1, const void * n2);//Die folgende generiert die Regeln
                                                 //fuer die Sortierung eines double-Arrays aufsteigend
int compare_doubles( const void *a, const void *b);
int compare_umhaengedaten( const void *a, const void *b);
int main(int argc, char * argv[]){
   int umhaengungen;
   int simulationen;
   static long s1, s2;
   int i_nr;
    int index;
   double baumalter;
   int vervollstaendigungsindex;
   char phrase[100];
   FILE * fp;
   char * st;  //Zeiger auf Baumstring (Dieser wird bearbeitet)
   char * c_pt;
   int anzahl_der_blaetter;
   struct stat stbuf;
	 struct umhaengedaten ** umhaengedaten_liste;

   
   //Eingabeparameter checken
   if(argc != 4){
     cout << "Falsche Parameterzahl!\n\n";
     cout << "Syntax: hgt_sim <Anzahl der Umhaengungen> <Anzahl der Simulationen> <Baumfile>\n";
   }else{
     umhaengungen = atoi(argv[1]);
     simulationen = atoi(argv[2]);

     umhaengedaten_liste = (struct umhaengedaten **) malloc (umhaengungen * sizeof(struct umhangedaten *));
     if(umhaengedaten_liste == NULL){
     	printf("Nicht genuegend Speicher fuer die umhaengedaten_liste.\n");

     }

     for(int i = 0; i < umhaengungen; i++){
     	umhaengedaten_liste[i] = (struct umhaengedaten *) malloc(sizeof(struct umhaengedaten));
     	if(umhaengedaten_liste[i] == NULL){
     		printf("Nicht genuegend Speicher fuer umhaengedaten:%i\n", i);
      	exit(1);
      	}
     }
     if((fp = fopen(argv[3], "r")) == NULL){
       cout << "Kann File nicht oeffnen.\n";
       exit(17);
     }
     if( stat( argv[3], &stbuf) == -1){
       cout << "Irgendwas mit dem Zugriff zur Datei geht schief.\n";
       exit(17);
     }
     //cout << "Die Datei hat" << stbuf.st_size << "Bytes";
     st = (char *) malloc((stbuf.st_size + 1) * sizeof(char));
     fread(st, stbuf.st_size, sizeof(char), fp);

     fclose(fp);
     anzahl_der_blaetter = 0;
     c_pt = st;
     while(*c_pt != ':'){
       anzahl_der_blaetter++;
       c_pt++;
     }
   }

   //Jetzt gehts los!!!!!!!!!!!
   sTree t(anzahl_der_blaetter);
   t.ReadString(st);
   baumalter = t.Baumalter();
   //Initialisierung des ZFZ-Gen
   
   sprintf(phrase, "%i", (int )time(NULL));
   phrtsd(phrase, &s1, &s2);
   setall(s1, s2);

//Ausdrucken der Intervallliste
   /*  for( int i = 0; i <= t.b; ++i){
       printf("%i: Start= %f Stop=%f Laenge=%f", i, t.intervall[i] -> start, t.intervall[i] -> stop, t.intervall[i] -> laenge);
       if(t.intervall[i] -> kanten != NULL){
	   for(int j = 0; j < i; ++j){
	       printf(" %s", t.intervall[i] -> kanten[j] -> node);
	   }
       }
       printf("\n");

   }
   */
   for(int sim = 0; sim < simulationen; sim++){
     t.ReadString(st);
     //Beschreiben des Arrays mit den zufaellig gezogenen Zeiten
     i_nr = 2;
     
     for(int i = 0; i < umhaengungen; i++){

       umhaengedaten_liste[i] -> zeit_im_baumgroessenintervall = ranf() * t.L;

     }
     if((vervollstaendigungsindex =
     t.VervollstaendigeUmhaengedaten(umhaengedaten_liste, umhaengungen)) > 0){
        printf("vervollstaendignung: %i::", vervollstaendigungsindex);
     }

/*for(int i = 0; i < umhaengungen; i++){
   printf("%f\n", umhaengedaten_liste[i] -> zeitpunkt);
}
printf("========\n");
*/
        qsort( umhaengedaten_liste,
             umhaengungen,
            sizeof(struct umhaengedaten *),
            &compare_umhaengedaten);
/*
for(int i = 0; i < umhaengungen; i++){
   printf("%f\n", umhaengedaten_liste[i] -> zeitpunkt);
}
*/
     for(int i = 0; i < umhaengungen; i++){
       int l;
       i_nr = t.BestimmeIntervall( umhaengedaten_liste[i] -> zeitpunkt);
       l = ZieheGanzeZahl(i_nr);


        index = t.HaengeZeitigUm( t.intervall[i_nr] -> kanten[ umhaengedaten_liste[i] -> lfd_nr_im_intervall ],
                                  t.intervall[i_nr] -> kanten[l],
                                  umhaengedaten_liste[i] -> zeitpunkt );
     }
     t.PrintTopologie();
     cout << "\n";
   }

   exit(0);
}
 
 //Die folgende Funktion bekommt eine Zahl und gibt zufaellig eine kleinere Zurueck.
 int ZieheGanzeZahl(int limit){
   double u;
   int i;
   u = ranf();
   if( u == 0 ){
     return 0;
   }
   i = 0;
   while(u > (double) (i + 1)/limit){
     i++;
   }
   return i;
}
//Die folgende Funktion generiert die aufsteigende Sortierung in einem Double-Array
int compare_doubles( const void *a, const void *b){
   double da, db;
   da = *(double *)a;
   db = *(double *)b;
   //printf("%1.3e - %1.3e = %1.3e\n", da, db, da - db);
   if(da - db < 0){
     return -1;
   }else if (da - db > 0){
     return 1;
   }else{
     return 0;
   }
   
}
// Die folgende Funktion generiert eine aufsteigende Sortierung der Liste mit den Umhaengedaten
int compare_umhaengedaten(const void * a, const void * b){
 const struct umhaengedaten *da;
 const struct umhaengedaten *db;

 da = *(struct umhaengedaten **) a;
 db = *(struct umhaengedaten **) b;

	if ( da -> zeitpunkt - db -> zeitpunkt < 0 ){
		return -1;
	}else if(da -> zeitpunkt - db -> zeitpunkt > 0 ){
	  return 1;
	}else if(da -> zeitpunkt == db -> zeitpunkt) {
	  return 0;
  }else{
  	printf("Fehler in Vergleichsfunktion compare_umhaengedaten.\n");
    exit(2);
  }

}

