#include <string.h>
#include <stringtree.h>
#include <ranlib.h>
#include <iostream.h>
#include <time.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>


#define frand() ((float) rand() / (RAND_MAX+1.0));

double next_time_step(double gen_trans_rate);
int ZieheGanzeZahl(int limit); //Funktion die eine ganze Zahl von Null bis unter die eingeg. Grenze angibt.
int comp_number(const void * n1, const void * n2);//Die folgende generiert die Regeln fuer die Sortierung eines double-Arrays aufsteigend
int compare_doubles( const void *a, const void *b);
int compare_umhaengedaten( const void *a, const void *b);

int main(int argc, char * argv[]){
   int umhaengungen;
   int simulationen;
   //double rate;////////////////////////////////////NEU
   double poissonvariable;
   static long s1, s2;
   int i_nr;
   int index;
   double baumalter;
   char phrase[100];
   FILE * fp;
   char * st;  //Zeiger auf Baumstring (Dieser wird bearbeitet)
   char * c_pt;
   int anzahl_der_blaetter;
   struct stat stbuf;
   struct umhaengedaten ** umhaengedaten_liste;
   int memsize_umhaengedaten_liste;
   
   //Eingabeparameter checken
   if(argc != 3){
     cout << "Falsche Parameterzahl!\n\n";
     cout << "Syntax: hgt_var_simrate <Anzahl der Simulationen> <Baumfile>\n";
   }
   else{
     simulationen = atoi(argv[1]);
     //Vorallokation fuer die Umnhaengedatenliste
     memsize_umhaengedaten_liste = 1;
     umhaengedaten_liste = (struct umhaengedaten **) malloc (1 * sizeof(struct umhangedaten *));
     if(umhaengedaten_liste == NULL){
     	printf("Nicht genuegend Speicher fuer die umhaengedaten_liste.\n");
     }
     umhaengedaten_liste[0] = (struct umhaengedaten *) malloc(sizeof(struct umhaengedaten));
     if(umhaengedaten_liste[0] == NULL){
       printf("Nicht genuegend Speicher fuer umhaengedaten:0\n");
       exit(1);
     }    
     if((fp = fopen(argv[2], "r")) == NULL){
       cout << "Kann File nicht oeffnen.\n";
       exit(17);
     }
     if( stat( argv[2], &stbuf) == -1){
       cout << "Irgendwas mit dem Zugriff zur Datei geht schief.\n";
       exit(17);
     }
     //cout << "Die Datei hat" << stbuf.st_size << "Bytes";
     st = (char *) malloc((stbuf.st_size + 1) * sizeof(char));
     fread(st, stbuf.st_size, sizeof(char), fp);
     fclose(fp);
     
     anzahl_der_blaetter = 0;
     c_pt = st;
     while(*c_pt != ':'){
       anzahl_der_blaetter++;
       c_pt++;
     }
   }

   //Jetzt gehts los!!!!!!!!!!!
   sTree t(anzahl_der_blaetter);
   t.ReadStringRates(st);
   //printf("Gesamte Baumgroesse: %f\n\n", t.L); 
   baumalter = t.Baumalter();
   //printf("Baumalter: %f\n\n", baumalter);  //baum ist clocklike, also eigentlich ueber ein bel. blatt ablesbar, da alle blaetter gleich weit von der wurzel entfernt sind 
   poissonvariable=t.bestimmePoissonvar();///////////////////////////////////////////NEU
   
   //Initialisierung des Zufallszahlengenerator
   sprintf(phrase, "%i", (int)time(NULL));
   phrtsd(phrase, &s1, &s2);
   setall(s1, s2);
   for(int sim = 0; sim < simulationen; sim++){
     t.ReadStringRates(st);     
     //Anzahl der Umhaengungen (Poissonverteilt)
     umhaengungen = ignpoi(poissonvariable);  /////////////////////////////////////////NEU
     printf("%i:", umhaengungen);     
     //Mehr Speicher fuer die umhaengedaten_liste falls notwendig
     if(memsize_umhaengedaten_liste < umhaengungen){
       umhaengedaten_liste = (struct umhaengedaten **) realloc(umhaengedaten_liste, umhaengungen * sizeof(struct umhaengedaten *));
       if(umhaengedaten_liste == NULL){
	 printf("Nicht genug Speicher in realloc fuer umhaengedaten_liste\n");
	 exit(2);
       }
       for(memsize_umhaengedaten_liste = memsize_umhaengedaten_liste; memsize_umhaengedaten_liste < umhaengungen; memsize_umhaengedaten_liste++){
	 umhaengedaten_liste[memsize_umhaengedaten_liste] = (struct umhaengedaten *) malloc(sizeof(struct umhaengedaten));
	 if(umhaengedaten_liste[memsize_umhaengedaten_liste] == NULL){
	   printf("Nicht genug Speicher fuer umhaengedaten_liste[%i]\n", memsize_umhaengedaten_liste);
	   exit(2);
	 }
       }
     }
     //Ende: mehr Speicher ...
     for(int i = 0; i < umhaengungen; i++){
       //ranf zufallszahl im intervall ]0;1[
       umhaengedaten_liste[i] -> zeit_im_raten_baumgroessenintervall = ranf() * poissonvariable;  //////////////////////////////////////NEU
       //printf("zeit im raten baumgroessenintervall %f\n", umhaengedaten_liste[i] -> zeit_im_raten_baumgroessenintervall);
     }
     //printf("\n");
     t.ZeitImBaumgroessenintervall(umhaengedaten_liste, umhaengungen);	////////////////////////NEU
     t.VervollstaendigeUmhaengedaten(umhaengedaten_liste, umhaengungen);
     //for(int i = 0; i < umhaengungen; i++){
         //printf("%f\n", umhaengedaten_liste[i] -> zeitpunkt);
     //}
     //printf("========\n");
     qsort(umhaengedaten_liste,			//sortiert zeit_im_baumgroessenintervall
           memsize_umhaengedaten_liste,
           sizeof(struct umhaengedaten *),
           &compare_umhaengedaten);
     //for(int i = 0; i < umhaengungen; i++){
       //printf("%f\n", umhaengedaten_liste[i] -> zeitpunkt);
     //}
     for(int i = 0; i < umhaengungen; i++){
       int l;
       i_nr = t.BestimmeIntervall(umhaengedaten_liste[i] -> zeitpunkt);
       l = ZieheGanzeZahl(i_nr);
       index = t.HaengeZeitigUm(t.intervall[i_nr] -> kanten[umhaengedaten_liste[i] -> lfd_nr_im_intervall], t.intervall[i_nr] -> kanten[l], umhaengedaten_liste[i] -> zeitpunkt);
     }
     //printf("%i: ", umhaengungen);
     t.PrintTopologie();
     cout << "\n";  
   }
   exit(0);  
}
 
//Die folgende Funktion bekommt eine Zahl und gibt zufaellig eine kleinere zurueck.
int ZieheGanzeZahl(int limit){
  double u;
  int i;
  u = ranf();
  if( u == 0 ){
    return 0;
  }
  i = 0;
  while(u > (double) (i + 1)/limit){
    i++;
  }
  return i;
}

//Die folgende Funktion generiert die aufsteigende Sortierung in einem Double-Array
int compare_doubles(const void *a, const void *b){
   double da, db;
   da = *(double *)a;
   db = *(double *)b;
   //printf("%1.3e - %1.3e = %1.3e\n", da, db, da - db);
   if(da - db < 0){
     return -1;
   }
   else if (da - db > 0){
     return 1;
   }
   else{
     return 0;
   }
}

//Die folgende Funktion generiert eine aufsteigende Sortierung der Liste mit den Umhaengedaten
int compare_umhaengedaten(const void * a, const void * b){
  const struct umhaengedaten *da;
  const struct umhaengedaten *db;

  da = *(struct umhaengedaten **) a;
  db = *(struct umhaengedaten **) b;
 
  if (da -> zeitpunkt - db -> zeitpunkt < 0){
    return -1;
  }
  else if(da -> zeitpunkt - db -> zeitpunkt > 0){
    return 1;
  }
  else if(da -> zeitpunkt == db -> zeitpunkt){
    return 0;
  }
  else{
    printf("Fehler in Vergleichsfunktion compare_umhaengedaten.\n");
    exit(2);
  }
}

double next_time_step(double gen_trans_rate){
  double u;
  u = ranf();
  //printf("Zz: %f\n", u);
  return (- log(1 - u) / gen_trans_rate);
}


