#include <stdlib.h>
#include <stdio.h>
#include <string.h>


struct IntNode{
	
  double geburt;
  double tod;
  char * node;
  struct IntNode * bruderkante;
  double rate;      			  	/////////////////////////////////////////////NEU
  double rechts_baumgroessenintervall;	 	/////////////////////////////////////////////NEU jeweils rechte intervallgrenze
  double rechts_ratenbaumgroessenintervall;	/////////////////////////////////////////////NEU jeweils rechte intervallgrenze
};


struct IntervallDaten{		//Zeitintervall
  double start;
  double stop;
  double laenge;
  struct IntNode ** kanten;
};

struct LebensIntervall{
  double von;
  double bis;
};

struct umhaengedaten{
  //gezogene hgt zeitpunkte
  double zeit_im_baumgroessenintervall;
  double zeit_im_raten_baumgroessenintervall;  //////////////////NEU
  double zeitpunkt;
  int kante;
  int intervall_nr;
  int lfd_nr_im_intervall;
};

class sTree
	{

  	public:
	  int n;  	//Anzahl der Knoten
	  int b; 	//anzahl der Blaetter
	  double L;  	//Summe aller Kantenlaengen
	  struct IntNode ** IntNode;
	  struct IntervallDaten  ** intervall;
	  
	  //Prototypen fuer die Konstruktoren und Destruktoren
	  
	  sTree (int i);	
	  
	  //Prototypen fuer die Methoden
	  void ReadString(char *);             //Einlesen eines Baumes in der Stringnotation mit einer konstanten HGT rate
/////////////////////////////////////////////////////////////NEU
	  void ReadStringRates(char *);        //Einlesen eines Baumes in der Stringnotation mit variablen HGT raten
	  void WriteIntervallData();           //Diese Funktion beschreibt die Intervallliste mit den Zeiten und den entsprechenden Kanten
	  void AgeSort();                      //Sortieren der Knoten nach Alter
	  void StringSort();                   //Sortieren der Knoten nach Bezeichnerlaenge und alphabetisch
    	  double Baumalter();                  //Gibt das Alter des Baumes an
	  
	  int HaengeZeitlosUm(struct IntNode * nodept1, struct IntNode * nodept2);  //Haengt Kante i in Kante j ohne Zeiten zu aendern
	                                                                            //Zurueckgegeben wird:
	                                                                            //0 falls nicht umgehaengt werden musste,
	                                                                            //1 falls umgeangt wurde aber die (ungewurzelte)
	                                                                            //  Topologie nicht veraendert wurde
	                                                                            //2 falls umgaengt und neue (auch ungewurzelte) Topologie
										
	  int sTree::HaengeZeitigUm(struct IntNode * nodept1, struct IntNode * nodept2, double time); 
                                                                                          //Haengt Kante j in Kante i mit Zeitpunkt zu aendern
                                                                                          //(Transfer von i nach j)
                                                                                          //Zurueckgegeben wird:
                                                                                          //0 falls nicht umgehaengt werden musste,
                                                                                          //1 falls umgeangt wurde aber die (ungewurzelte)
                                                                                          //  Topologie nicht veraendert wurde
                                                                                          //2 falls umgaengt und neue (auch ungewurzelte) Topologie

	  int sTree::VervollstaendigeUmhaengedaten(struct umhaengedaten ** liste, int anzahl);
	                                                                   //Diese Funktion bekommt die Liste mit den Umhaengedaten
	                                                                   //und traegt die Kanten und die Zeitpunkte ein.    
	
////////////////////////////////////////////////////////////////NEU 
	  void sTree::ZeitImBaumgroessenintervall(struct umhaengedaten ** liste, int anzahl); //diese Funktion bekommt die Liste mit den
	  										      //Umhaengedaten sowie die anzahl der umhaengungen
										              //und traegt zu jeder zeit im raten-
										              //baumgroessenintervall das baumgroessenintervall ein
	  	                                                           
          struct IntNode *  ElternBestimmung(struct IntNode * nodept);  //Diese Funktion gibt einen Zeiger auf
                                                                        //den Elternknotens zum uebergebenen
                                                                        //Knoten (zeiger)
								      
          struct IntNode *  BruderBestimmung(struct IntNode * nodept); //Diese Funktion gibt einen Zeiger auf die Bruderkante zum uebergebenen
                                                                       //Knoten (~Kante). Bruderkante = Kante mit gleichen Eltern
                                                                       //Bruder(Wurzelkante) := Wurzelknoten
								      
          double GemeinsameLebenszeit(struct IntNode * p1, struct IntNode * p2); //Diese Funktion bekommt Zeiger auf zwei Knoten und
                                                                                 //berechnet die Laenge des gemeinsamen  Lebensintervall
										
          struct LebensIntervall GemeinsamesLebensintervall(struct IntNode * p1, struct  IntNode * p2);  //Diese Funktion bekommt Zeiger auf zwei
	                                                                                                 //Knoten und gibt das gemeinsame
													 //Lebensintervall zurueck
	  
          double BerechneWkeit(struct  IntNode * p1, struct IntNode * p2); //Diese Funktion berechnet die Wahrscheinlichkeit, dass
                                                                           //zwischen den angegebenen Kanten horizontaler Gentransfer stattfindet

          void sTree::PrintTopologie();  //Diese Funktion schreibt die Baumtopologie (sortiert als Sring) auf die Ausgabe
	  
          int BestimmeIntervall(double time);  //Diese Funktion bekommt eine Zeit und gibt die Nr. des Intervalls zurueck,
                                               //in das diese Zeit faellt
	
//////////////////////////////////////////////////////////////NEU 		     
          double bestimmePoissonvar();	//bestimmt die poissonvariable bei baeumen mit unterschiedlichen hgt raten an den aesten
	                                //(summe(rate(i)*laenge(i)))

};

