#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_randist.h>

#define MAX_ZEILENLAENGE  1200000

struct ZEILE{
  int umh;
  int * genbaumhaeufigkeit;
  double poisson_value;
  struct ZEILE * next;
};

int zaehle_zeilenelemente(char * string);



int main(int argc, char * argv[]){
  
  char  dateizeile[MAX_ZEILENLAENGE];
  int i;
  int j;
  struct ZEILE  *  matrix;
  struct ZEILE  * matrix_firstline;
  struct ZEILE ** MATRIX;
  int zeilenelemente;
  int zeilenanzahl;
  FILE * fp;
  char * c_pt_1;
  char * c_pt_2;
  double start_rate, stop_rate, step_rate, baumlaenge;
  double cur_rate;
  double temp_var;
  int sim_anzahl;
  double poisson_sum;
  double cur_lh_val;
  double max_lh_val;
  double max_lh_rate;
  if(argc != 7){
    printf("Usage: matrix2lh_val matrixdatei start_rate stop_rate step_rate baumlaenge sim_anzahl \n\n");
    exit(1);
  }
  start_rate = atof(argv[2]);
  stop_rate = atof(argv[3]);
  step_rate = atof(argv[4]);
  baumlaenge = atof(argv[5]);
  sim_anzahl = atoi(argv[6]);

  if((fp = fopen(argv[1], "r")) == NULL){
    printf("Fehler beim oeffnen der datei %s\n", argv[1]);
    exit(2);
  }
  
  //Speicheranforderung fuer die Matrix
  if((matrix = (struct ZEILE *) malloc(sizeof(struct ZEILE))) == NULL){
      printf("Fehler bei Speicheranforderung fuer Matrixzeile.\n");
      exit(1);
  }
  //Einlesen der Matrix in eine verkettete Liste
  matrix_firstline = matrix;  
  zeilenanzahl = -1; 
  while(matrix != NULL){
    ++zeilenanzahl;
 
    if( fgets(dateizeile, MAX_ZEILENLAENGE, fp) == NULL){
      matrix = NULL;
      
    }else{
      c_pt_1 = dateizeile;
      //printf("%s", dateizeile);
      zeilenelemente = zaehle_zeilenelemente(dateizeile);
      if((matrix -> genbaumhaeufigkeit = (int *) malloc (zeilenelemente * sizeof(int))) == NULL){
	printf("Fehler bei Speicheranforderung fuer Zeilenelemente.\n");
	exit(1);
      }
      c_pt_2 =  strchr(c_pt_1, ':');
      *c_pt_2 = '\0';
      matrix -> umh = atoi(c_pt_1);
      
      c_pt_1 = &c_pt_2[1];  
      for(i = 0; i < zeilenelemente; ++i){
	
	if((c_pt_2 = strchr(c_pt_1, ',')) != NULL){
	  *c_pt_2 = '\0';
	}  
	
	matrix -> genbaumhaeufigkeit[i] = atoi(c_pt_1); 
	
	c_pt_1 = &c_pt_2[1];
      }
       
      if((matrix -> next = (struct ZEILE *) malloc(sizeof(struct ZEILE))) == NULL){
	printf("Fehler bei Speicheranforderung fuer Matrixzeile.\n");
	exit(1);
      }
      matrix = matrix -> next;
		
    }
   
  }//ENDE WHILE (matrix != NULL){...
  

  fclose(fp);
   //Matrix eingelesen und Datei geschlossen
  
  //Nun wird ein Array mit Zeigern auf die Matrixelemente erstellt
  // somit kann auf die Matrix wie auf eine Matrix zugegriffen werden
  if((MATRIX = (struct ZEILE **) malloc(zeilenanzahl * sizeof(struct ZEILE *))) == NULL){
    printf("Fehler bei Speicheranforderung fuer MATRIX.\n");
    exit(1);
  }
 
  matrix = matrix_firstline;
  MATRIX[0] = matrix_firstline;
 
  for(i = 1; i < zeilenanzahl; ++i){
    
    MATRIX[i] = MATRIX[i - 1] -> next;
    
  }
 
  //MATRIX fertig
  
  //Berechnung der ML-Werte
  max_lh_val = - 10000000;
  for(cur_rate = start_rate; cur_rate <= stop_rate; cur_rate += step_rate){
    poisson_sum = 0;
     for(i = 0; i < zeilenanzahl; ++i){
       MATRIX[i] -> poisson_value = gsl_ran_poisson_pdf( MATRIX[i] -> umh,  cur_rate * baumlaenge);
       //printf("POISSON(%i) = %f\n", i,  MATRIX[i] -> poisson_value);
       poisson_sum += MATRIX[i] -> poisson_value;
      
     }
     //printf("POISSONSUM = %f\n",   poisson_sum);
     
     cur_lh_val = 0;
     
     for(j = 0; j < zeilenelemente; ++j){
       temp_var = 0;
       for(i = 0; i < zeilenanzahl; ++i){

	 temp_var += MATRIX[i] -> poisson_value * MATRIX[i] -> genbaumhaeufigkeit[j] / sim_anzahl;
	 // printf("temp_var = %f i=%i j = %i\n", temp_var, i, j);
       }
       
       if(temp_var > 0.0000){
	 cur_lh_val += log(temp_var);
	 if(temp_var > 1){
	   printf("Tempvar=%f  zu gross (> 1)\n", temp_var);
	   exit(4);
	 }
       }else if(temp_var < 0){
	 printf("Fehler in der Berechnung der LH-Werte.\n");
	 exit(4);
       }
     }
     printf("rate= %f lh_val= %f\n", cur_rate, cur_lh_val);
     if(max_lh_val < cur_lh_val){
       max_lh_val = cur_lh_val;
       max_lh_rate = cur_rate;
     }
  }
  printf("MaxLHRate= %f MaxLhVal= %f\n", max_lh_rate, max_lh_val);
}
    
   


/*
double poisson(int n, double rate, double laenge){
  
  return (pow(rate * laenge, n)) / (exp( rate * laenge) * fak(n));
}
  

int fak(int in){
  
  if(in == 0 || in == 1){
    return 1;
  }

  return in * fak(in - 1);
  
}
*/  
    


int zaehle_zeilenelemente(char * string){
  int anzahl;
  if(strlen(string) == 0){
    return 0;
  }else{
    anzahl = 1;
  }

  while(*string != '\0' && *string != '\n'){
    if(*string == ',' && *(string+1) != '\n'){
      ++anzahl;
    }
    ++string;
  }
  
  return anzahl;
}
  
