#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <compares.h>
#include <topology.h>


int match_treenodes_to_list(struct node ** list, struct node * pt, int anzahl);
int print_treestring_mit_alter(struct node * knoten);
int comp_nodelist(const void * s1, const void * s2);

void main(int argc, char * argv[]){

  treelist tree;
  FILE *fp;
  int anzahl_knoten;
  char ** tree_topology;
  int i;
  struct node ** nodelist;

  if((fp = fopen(argv[1], "r")) == NULL){ // Oeffnen des Files mit Newickbaum
  printf("Fehler in main() beim Dateizugriff (lesend)!\n");
  exit(1);
  }


  tree = readNewickTreeFile(fp, 0); //Einlesen des Baumes 
  create_null_childs(tree[0].leave);

 
  // rewrite_edgelength2age(tree[0].leave);
 
  write_labels_in_tree(tree[0].leave);
  anzahl_knoten = count_knoten(tree[0].leave, 0);
  if((nodelist = (struct node **) malloc ( anzahl_knoten * sizeof(struct node *))) == NULL){
    printf("Feler in beim Speicherallokieren fuer nodelist.\n");
    exit(2);
  }
  
  
  close(fp);
  match_treenodes_to_list(nodelist, tree[0].leave, anzahl_knoten);

  
  
  
  qsort(nodelist, anzahl_knoten, sizeof(struct node *), comp_nodelist);
  printf("%s:%f", nodelist[0] -> label, nodelist[0] -> edgelength);
  for(i = 1; i < anzahl_knoten; ++i){
    printf(" %s:%f", nodelist[i] -> label, nodelist[i] -> edgelength);
  }
  
  printf("\n");
  exit(1);




}
//Die folgende Funktion bekommt einen Array mit Zeigern auf Baumknoten und sortiert diese nach Laenge und
//alphabetisch bezueglich der Label
int comp_nodelist(const void * s1, const void * s2){
  struct node * n1;
  struct node * n2;
  
  n1 = *(struct node **) s1;
  n2 = *(struct node **) s2;
  if(strlen(n1 -> label) > strlen(n2 -> label)){
    return -1;
  }else if(strlen(n1 -> label) == strlen(n2 -> label)){
    return strcmp(n1 -> label, n2 -> label);
  }else{
    return 1;
  }

}



// Die folgende Funktion bekommt einen Zeiger auf einen Knoten in einem Baum und gibt den Namen des Knoten,
// sowie der direkten Kinderknoten aus (rekursiv)
int print_treestring_mit_alter(struct node * knoten){
  //printf("%s %s %s\n", knoten->label, knoten->edges[0]->label, knoten->edges[1]->label);
  if(knoten->edges[0] != NULL){
    printf("%s:%f ", knoten->label, knoten->edgelength);
    print_treestring_mit_alter(knoten -> edges[0]);
  }else{
    printf("%s:%f ", knoten->label, knoten -> edgelength);
    return 1;
  }
  if(knoten->edges[0] != NULL){
    //printf("%s %s %s\n", knoten->label, knoten->edges[0]->label, knoten->edges[1]->label);
    print_treestring_mit_alter(knoten->edges[1]);
  }else{
    return 1;
  }

}

//Die filgende Funktion erghaelt einen Array mit Zeigern auf Knoten, den Zeiger auf eine Baumwurzel und
//die Anzahl der Knoten im Baum. Dann werden die Zeiger in der Liste auf die Baumknoten gesetzt.
int match_treenodes_to_list(struct node ** list, struct node * root_ptr, int anzahl){
  static int nr = 0;
  if(root_ptr -> edges[0] != NULL){
    list[nr] = root_ptr;
    ++nr;
    nr = nr % anzahl;
    match_treenodes_to_list(list, root_ptr -> edges[0], anzahl);
  }else{
    list[nr] = root_ptr;
    ++nr;
    nr = nr % anzahl;
    return 1;
  }
  if(root_ptr -> edges[0] != NULL){
    match_treenodes_to_list(list, root_ptr -> edges[1], anzahl);
  }else{
    return 1;
  }
  return 1;
}
