
package TreeFormat;

# make_root : Eingabe (ungew.) NewickString 
#             Ausgabe: bel. gew. NewickString

# extract_subtree_weak_version : Eingabe 1) gew. Baumstring 2) SpeziesnamenString (1Letter)
#                                Ausgabe: Unterbaum in Stringnotation wird zurueckgegeben 
#                                       evntl mit dopplt. Knoten und unsortiert

# treestring2topology : Eingabe gew. Stringbaum
#                        Ausgabe: ungew. Topologie (String) 



#=============================================================================================
#=============================================================================================

# Die folgende Funktion bekommt einen Newickstring (ungewurzelt) 
# und setzt zwei Klammern so, das ein gewurzelter String
# entsteht
sub make_root(){

    my $unrooted_tree = $_[0];
    

    if(substr($unrooted_tree, 3, 1) ne "("){
	
	return "(" . substr($unrooted_tree, 0, 4) . ")" . substr($unrooted_tree,4);
    }else{
	my $counter = 2;
	my $i = 4;
	while($counter != 1 && $i <= length($unrooted_tree)){
	    if(substr($unrooted_tree, $i, 1) eq "("){
		$counter++;
	    }elsif(substr($unrooted_tree, $i, 1) eq ")"){
		$counter--;
	    }
	    $i++;
	}
	return "(" . substr($unrooted_tree, 0, $i) . ")" . substr($unrooted_tree, $i);
    }
}



# Die folgende Funktion bekommt einen gewurzelten Baum in Stringnotation und
# einen String mit Speziesnamen. Dann wird der zu den Speziesnamen assoziierte Unterbaum in Stringnotation
# extrahiert. Dabei werden doppelt genannte Knoten nicht entfernt und die Knotenbezeichner sind nicht sortiert.
sub extract_subtree_weak_version(){
    my $treestring = $_[0];
    my $subtree_speziesstring = $_[1];

    my @TREESTRING = split(/ /, $treestring);
    my $treeroot = $TREESTRING[0];
    my $spezies_subtree_anzahl = length($subtree_speziesstring);

    my @SUBTREESTRING = ();
    
    
    foreach my $node (@TREESTRING){
	my $tempvar = "";
	for(my $i = 0; $i < $spezies_subtree_anzahl; $i++){
	    if( index($node, substr($subtree_speziesstring, $i, 1)) >= 0){
		$tempvar = $tempvar .substr($subtree_speziesstring, $i, 1);
	    }
	}
	if(length($tempvar) > 0){
	    @SUBTREESTRING = (@SUBTREESTRING, $tempvar);
	}
    }
    @SUBTREESTRING = make_array_unique(@SUBTREESTRING);
    @SUBTREESTRING = sort {if(length($a) < length($b)){
	                     return 1;
			 }elsif(length($a) == length($b)){
			     $a cmp $b;
			 }else{
			     return -1;
			 }
				 
		       } @SUBTREESTRING;
    return join(" ", @SUBTREESTRING);
}



# Die folgende Funktion bekommt einen gewurzelten Baum in Stringnotation und gibt dessen
# ungewurzelte Topologie zurueck.
sub treestring2topology(){
    my @rooted_tree = split(/ /, $_[0]);
    
    my $spezies_string = $rooted_tree[0];
   	

    my $anzahl = length($spezies_string);
  
    my @unrooted_tree = ();
    foreach my $tree (@rooted_tree){
	
	if(length($tree) < $anzahl - 1 && length($tree) > 1){
	    @unrooted_tree = (@unrooted_tree, $tree);
	}
    }
    
    for(my $i = 0; $i <= $#unrooted_tree; $i++){
	$unrooted_tree[$i] = &finde_komplement($spezies_string, $unrooted_tree[$i]);

    }
    @unrooted_tree = &make_array_unique(@unrooted_tree);
   
    return join(" ", @unrooted_tree);
	
    
}  

#Die folgende Funktion bekommt einen  Array und gibt einen
# sortierten zurueck, wobei nun jeder Wert nur einmal vorkommt
sub make_array_unique(){
    my @array = @_;
   
    @array = sort(@array);
    my @unique_sort_array = ();

    $unique_sort_array[0] = $array[0];
    
    for(my $i = 1; $i <= $#array; $i++){
	if( $array[$i] ne $array[$i - 1]){
	    @unique_sort_array = (@unique_sort_array, $array[$i]);
	}
	
    }
	

    return @unique_sort_array;
}
 
#Die folgende Funktion bekoomt zwei Strings (alphabetisch sortiert
#und ergaenzt den zweiten um "|xxx" wobei xxx fuer alle Elemente aus dem ersten String steht
#welche nicht im zweiten enthalten sind    
sub finde_komplement(){

    my $complete = $_[0];
    my $part = $_[1];

    my $complement = "";
    for(my $i = 0; $i < length($complete); $i++){
	if(index($part, substr($complete, $i, 1)) == -1){
	    $complement = $complement . substr($complete, $i, 1);
	}
    }
    if($part le $complement){
	return $part . "|" . $complement;
    }else{
	return $complement . "|" . $part;
    }
    
}
1;



























