#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <filefctns.h>
#include <string.h>
#include <treeformat.h>
#include <compares.h>

#define zeilenpuffer 4096



struct SIM_DATA{
  char * datafile;
  int zeilenanzahl;
  char  zeile[zeilenpuffer];
  int spezies_anzahl;
  
};


int extract_subtrees(char * tree,                 //String mit ungewurzelter Baumtopologie
		     struct cog_gentree *** gentree,//Struktur: Genbaum,
		     char ** subtree_cand,              //Ergebnisstring: 100011...
		     char *** BIG_TREE,             //Array mit Zeiger auf Knoten im Baum
		     int anzahl_tree_knoten,       //Anzahl der Knoten im Baum
		     int anzahl_genbaeume,          //Anzahl der Genbaeume
		     char ** result,          //UnterbaumKandidat
		     char *** SUBTREE_CAND    //Array um die Unterbaumknoten zu speichern
		     );


int read_genetrees(char * filename, struct cog_gentree *** list);  

int main(int argc, char * argv[]){
  
  char * gentrees_data_file;
  int gentrees_zeilenanzahl;
  int umh;
 //char * gentrees_data;
// char ** gentrees_data_zeilen;
  int i;
  char ** BIG_TREE;
  struct SIM_DATA SIM_DATA;
 struct cog_gentree ** COG_GENTREES;
  char * subtree_cand;
  char ** SUBTREE_CAND;  
  char subtree_result[4096];
  FILE * filept;

  if(argc != 5){
    printf("\nUSAGE: subtree_finder <SIM_DATA_FILE> <GENTREES_DATA_FILE> <UMH> <SIM_DATA:spezies_anzahl>\n\n");
    printf("DATEIFORMATE\n");
    printf("SIM_DATA:\nABCDE ABCD ABC AB A B C D E\nABCDE ABC AB CD A B C D E\n\n");
    printf("GEN_TREES:\n2\n1:ABCD:AB|CD\n2:ABCDE:ABC|CD ADE|BC\n\n");
    exit(1);
  }
  SIM_DATA.datafile = argv[1];
  gentrees_data_file = argv[2];
  umh = atoi(argv[3]);
  SIM_DATA.spezies_anzahl = atoi(argv[4]);;
 
  //Einlesen der Genbaeume  
 //gentrees_zeilenanzahl = readFile2Array(gentrees_data_file, &gentrees_data_zeilen, &gentrees_data); 
 
  //Einlesen der Simulationsdaten
  //SIM_DATA.zeilenanzahl = readFile2Array(SIM_DATA.datafile, &SIM_DATA.zeilen, &SIM_DATA.data);
  
  
 
  
  if((BIG_TREE = (char **) malloc (((2 * SIM_DATA.spezies_anzahl) - 1) * sizeof(char *))) == NULL){
    printf("Fehler bei der Speicherallokation. 1\n");
    exit(1);
  }
 
  
  if((SUBTREE_CAND = (char **) malloc (((2 * SIM_DATA.spezies_anzahl)  - 1) * sizeof(char *))) == NULL){
    printf("Fehler bei der Speicherallokation. 1\n");
    exit(1);
  }
  for(i = 0; i < ((2 * SIM_DATA.spezies_anzahl) - 1); i++){
    SUBTREE_CAND[i] = (char *) malloc ((SIM_DATA.spezies_anzahl + 1) * sizeof(char *));
  }
  gentrees_zeilenanzahl = read_genetrees(gentrees_data_file, &COG_GENTREES);
  //Allokation von Speicher fuer den Subtree Kandidaten
  subtree_cand = (char *) malloc ((gentrees_zeilenanzahl + 1) * sizeof(char));


 if( (filept = fopen(SIM_DATA.datafile, "r")) == NULL){
 	printf("Fehler beim Oeffnen der Datei: %s\n", SIM_DATA.datafile);
 }
 

  i=0;
  while((fgets(SIM_DATA.zeile, zeilenpuffer, filept) != NULL)){
  	char * pt;
  	char * sr_pt;
 
	
  	i++;
  	
 	if((pt = strchr(SIM_DATA.zeile, '\n')) != NULL){
  		*pt = '\0';
  		
  	}
	
 	pt = SIM_DATA.zeile;

 	sr_pt = subtree_result;
	
 	printf("%i,%s,", umh, pt);
  	extract_subtree(&pt, &COG_GENTREES, &subtree_cand, &BIG_TREE, SIM_DATA.spezies_anzahl, 
    	              gentrees_zeilenanzahl, &sr_pt, &SUBTREE_CAND);

  }
  fclose(filept);
  return 0;
}

int extract_subtree(char ** tree,                       //String mit ungewurzelter Baumtopologie
		    struct cog_gentree *** gentree,//Struktur: Genbaum,
		    char ** subtree_cand,               //Ergebnisstring: 100011...
		    char *** BIG_TREE,            //Array mit Zeiger auf Knoten im Baum
		    int anzahl_tree_knoten,         //Anzahl der Knoten im Baum
		    int anzahl_genbaeume,         //Anzahl der Genbaeume
		    char ** result,          //UnterbaumKandidat
		    char *** SUBTREE_CAND    //Array um die Unterbaumknoten zu speichern
			 ){
  int i, j;
  char * pt;
  char * pp;
  char * completion_string_1;
  char * completion_string_2;
  char  subtree_cand[2048];
  
  pt = *tree;
  completion_string_1 = (char *) malloc ( (anzahl_tree_knoten + 1 ) * sizeof(char)); 
  completion_string_2 = (char *) malloc ( (anzahl_tree_knoten + 1 ) * sizeof(char)); 
  i = 0;
 
  //  printf("%s\n", *tree);
 
  //Zerlegung des Strings mit der gewurzelten Baumtopologie in einzelne Knoten
  (*BIG_TREE)[0] = (*tree);
  
  //printf("Anzahl=%i\n", anzahl_tree_knoten);

  while(*pt != '\0' && i <  (2 * anzahl_tree_knoten ) ){
    
    if(*pt == ' '){
      
      *pt = '\0';
       
      pt++;
      i++;
     
      (*BIG_TREE)[i] = pt;
      
    
    }else{      
      pt++;
      
    }
   
  }
  
  //result)[0] = '\0';
  
    //Fuer jden Genbaum: Erstelle den Unterbaum des gr. baumes bestehend aus den Spezies
    //des Genbaumes
  for(i = 0; i < anzahl_genbaeume; i++){
    //printf("%s\n", (*gentree)[i] -> pure_topology);
    for(j = 0; j < (2 * anzahl_tree_knoten - 1); j++){
       pt = (*gentree)[i] -> spezies;
      
       (*SUBTREE_CAND)[j][0] = '\0';
       //printf("Suche %s in: %s\n", pt, (*BIG_TREE)[j]);
      
      while(*pt != '\0'){
		 			
		if((pp = (strchr((*BIG_TREE)[j], *pt))) != NULL){
	  		//printf("PP = %c", *pp);
	  		strncat((*SUBTREE_CAND)[j], pt, 1);	  
		}	
		pt++;
      }
      //printf("%i: Gefunden: %s\n", j,(*SUBTREE_CAND)[j]);
      //Ergaenze jden Knotenbezeichner durch die rein topologische Bezeichnung
      //printf("Laenge:%i\n", strlen( (*SUBTREE_CAND)[j]) );
    	if(strlen( (*SUBTREE_CAND)[j]) < 2){
    		
    		(*SUBTREE_CAND)[j][0] = '\0';
    	}else{
    		completion_string_1[0] = '\0';
    		completion_string_2[0] = '\0';
    		strcpy(completion_string_1, (*SUBTREE_CAND)[j]);
    		pt =(*gentree)[i] -> spezies;
    		while(*pt != '\0'){
    			if ( (pp = strchr( (*SUBTREE_CAND)[j], *pt)) == NULL){
    				strncat(completion_string_2, pt, 1);
    			}
    			pt++;
    		}
    		(*SUBTREE_CAND)[j][0] = '\0';
    		//printf("%s|%s\n", completion_string_1, completion_string_2);
    		if(strlen(completion_string_1) > 1 && strlen(completion_string_2) > 1){
    		   	
    			if(strcmp(completion_string_1, completion_string_2) < 0){
    				strcpy((*SUBTREE_CAND)[j], completion_string_1);
    				strcat((*SUBTREE_CAND)[j], "|");
    				strcat((*SUBTREE_CAND)[j], completion_string_2);
    			}else if(strcmp(completion_string_1, completion_string_2) > 0){
    				strcpy((*SUBTREE_CAND)[j], completion_string_2);
    				strcat((*SUBTREE_CAND)[j], "|");
    				strcat((*SUBTREE_CAND)[j], completion_string_1);
    			}else{
    				printf("Fehler\n");
    			}
    		//printf("->%s\n", (*SUBTREE_CAND)[j]);   	
    		}
	
   		 }
    	 
    	}//Ende der FOR-Schleife fuer j
    	
    	qsort((*SUBTREE_CAND), 2 * anzahl_tree_knoten - 1, sizeof(char *), &stringcomp);
    	subtree_cand[0] = '\0';
    	j = 0;
    	pt = (*SUBTREE_CAND)[0];
    	while(*pt == '\0' && j < 2 * anzahl_tree_knoten - 2){
    		j++;
    		pt = (*SUBTREE_CAND)[j];
    	}
    	if(j == 2 * anzahl_tree_knoten - 1){
    		printf("Probleme mit den Unterbaeumen.\n");
    		exit(2);
    	}
    	
    	//pt = (*SUBTREE_CAND)[j];
    	strcpy(subtree_cand, pt);
    	j++;
    	for(j = j; j < 2 * anzahl_tree_knoten - 1; j++){
    		pp = (*SUBTREE_CAND)[j];
    		if(strcmp(pt, pp) != 0){
    			strcat(subtree_cand, " ");
    			strcat(subtree_cand, pp);
    		}
    		pt = pp;
    	}
    		
    	//printf("%s\n", subtree_cand);	
    	//printf("%s\n", (*gentree)[i]  -> pure_topology);
    	if(strcmp(subtree_cand, (*gentree)[i] -> pure_topology) == 0){
    		printf("1");
    	}else{
    		printf("0");
    	}
    	
  	}//Ende der FOR-Schleife fuer i
  printf("\n");

  return 1;
}
    
  
    
int read_genetrees(char * filename, struct cog_gentree *** list){
  int i;
  FILE * fp;
  char * pt1;
  char * pt2;
  struct stat fileinfo;
  char dateizeile[4096];
  int zeilenanzahl;

  if( stat(filename, &fileinfo) == -1 ){
    printf("Konnte keine Infos zu Datei %s erhalten.\n", filename);
    return -1;
  }


 
  if((fp = fopen(filename, "r")) == NULL){
    printf("Konnte Datei %s nicht oeffnen.\n", filename);
    return -1;
  }
  if(fgets(dateizeile, 4096, fp) == NULL){
    printf("Fehler beim Lesen.\n");
    exit(2);
  }
  pt1 = strchr(dateizeile, '\n');
  *pt1 = '\0';
  zeilenanzahl = atoi(dateizeile);
  if((*list = (struct cog_gentree **)  malloc(zeilenanzahl * sizeof(struct cog_gentree *))) == NULL){
    printf("Speicher fuer henetrees_list konnnte nicht allokiert werden.");
    exit(2);
  }
  for(i = 0; i < zeilenanzahl; i++){
    if((fgets(dateizeile, 4096, fp)) == NULL){
      printf("Fehler beim Lesen.\n");
      exit(2);
    }else{
      pt1 = strchr(dateizeile, '\n');
      *pt1 = '\0';
    }
    if(((*list)[i] = (struct cog_gentree *) malloc(sizeof(struct cog_gentree)) ) == NULL){
      printf("Fehler bei der Speicheranforderung fuer genetrees[%i]\n", i);
      exit(2);
    };
    pt1 = dateizeile;
    pt2 = strchr(pt1, ':');
    *pt2 = '\0';
    (*list)[i] -> lfd_nr = atoi(pt1);
    pt1 = ++pt2;
    pt2 = strchr(pt1, ':');
    *pt2 = '\0';
    if(((*list)[i] -> spezies = (char *) malloc((strlen(pt1) + 1) * sizeof(char))) == NULL){
      printf("Kein Speicher fuer genetrees_list[%i].species\n", i);
      exit(2);
    }else{
      strcpy((*list)[i] -> spezies, pt1);
    }
      pt1 = ++pt2;
    
    if(((*list)[i] -> pure_topology = (char *) malloc((strlen(pt1) + 1) * sizeof(char))) == NULL){
      printf("Kein Speicher fuer genetrees_list[%i].pure_topology\n", i);
      exit(2);
    }else{
      strcpy((*list)[i] -> pure_topology, pt1);
    }
    
  }
  fclose(fp);
 
    
  

  close(fp);

  return zeilenanzahl;
}
 
